package test.test.test;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Date;
import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TransactionRolledBackException;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import twitter4j.Device;

public class Publisher
{
   public static void main(final String[] args) throws IOException, NamingException, JMSException
   {
      Connection connection = null;
      InitialContext initialContext = null;
      Date startDate=new Date();
      try
      {
    	  String jndiFilename = "client-jndi.properties";
	      File jndiFile = new File(jndiFilename);
	      Properties props = new Properties();
	      FileInputStream inStream = null;
	      try
	      {
	         inStream = new FileInputStream(jndiFile);
	         props.load(inStream);
	      }
	      finally
	      {
	         if (inStream != null)
	         {
	            inStream.close();
	         }
	      }
	     initialContext=new InitialContext(props);
         Topic topic = (Topic)initialContext.lookup("/topic/exampleTopic");
         ConnectionFactory cf = (ConnectionFactory)initialContext.lookup("/ConnectionFactory");
         
         connection = cf.createConnection();
         connection.setClientID("client1");
         Session session = connection.createSession(false,Session.DUPS_OK_ACKNOWLEDGE);
         MessageProducer producer = session.createProducer(topic);
         producer.setDeliveryMode(DeliveryMode.PERSISTENT);
         int numMessages=10;
         startDate=new Date();
         for (int i = 0; i < numMessages; i++)
         {
        		TextMessage message = session.createTextMessage("Venkateshb"+i);
        		message.setJMSDeliveryMode(DeliveryMode.PERSISTENT);
                producer.send(message);
         }

         connection.start();
         System.out.println(startDate);
         System.out.println(new Date());
      }
      finally
      {
         if (connection != null)
         {
            connection.close();
         }
         if (initialContext != null)
         {
            initialContext.close();
         }
      }
   }
}
